world
	view=5
	turf=/turf/grass
	name = "Volte's Dynamic Lighting"
mob/icon='Icons.dmi'
obj/LightSource
	icon='Icons.dmi'
	icon_state="light"
	var/brightness=255 // Something I was toying with, just judges how dark the shadow is
	New()
		..() // This is just for effect, makes the grass around it lighter when it's created
		for(var/turf/grass/G in getcircle(src,5))
			G.icon+=rgb(30,30,30)
		for(var/turf/grass/G in getcircle(src,3))
			G.icon+=rgb(60,60,60)
		for(var/turf/grass/G in getcircle(src,1))
			G.icon+=rgb(80,80,80)
	Del() // Same as above, but makes it darker.
		for(var/turf/grass/G in getcircle(src,5))
			G.icon-=rgb(30,30,30)
		for(var/turf/grass/G in getcircle(src,3))
			G.icon-=rgb(60,60,60)
		for(var/turf/grass/G in getcircle(src,1))
			G.icon-=rgb(80,80,80)
		..()
turf/grass
	icon='Icons.dmi'
	icon_state="grass"
client/Move()
	..() // Everytime you move, update your shadow.
	mob.UpdateShadow()

mob/verb/Change_Icon(I as icon,Is as text)
	src.icon=I
	src.icon_state=Is
	src.UpdateShadow()

mob/verb/Create_Light()
	new/obj/LightSource(src.loc)

mob/proc/UpdateShadow()
	for(var/I in src.underlays) src.underlays -= I // First, remove all underlays.
	for(var/obj/LightSource/Light in view(src))
		var/obj/NewObj=new()
		var/BrightSubtract=Light.brightness
		var/angle = GetAngle(Light,src) // Calculate the angle from the light to you only once; less processing.
		var/thedir
		var/CheckDir=src.dir // This chunk of code messes with directions of the shadows. (So it looks 'realistic')
							 // Not entirely finished, but enough for you to get the idea.
		if(get_dir(Light,src)==EAST||get_dir(Light,src)==WEST)
			if(CheckDir==EAST||CheckDir==WEST) thedir=SOUTH
			if(CheckDir==NORTH||CheckDir==SOUTH) thedir=EAST
		NewObj.icon = icon(src.icon,src.icon_state,thedir) // Duplicate src's icon, and darken it the right amount
		NewObj.icon+=rgb(255,255,255)
		NewObj.icon-=rgb(BrightSubtract,BrightSubtract,BrightSubtract)

		var/icon/I=new(NewObj.icon)
		I.Turn(angle) // Turn the shadow in the right direction.
		NewObj.icon=I
		NewObj.pixel_x += cos(90-angle) * 16 // Displace the shadow correctly.
		NewObj.pixel_y += sin(90-angle) * 16 - 16
		src.underlays+=NewObj

proc/GetAngle(atom/Ref,atom/Target) // This is just a procedure to get the angle between two atoms.
	var/dx = ((Target.x * 32) + Target.pixel_x - 16) - ((Ref.x*32) + Ref.pixel_x - 16)
	var/dy = ((Target.y * 32) + Target.pixel_y - 16) - ((Ref.y*32) + Ref.pixel_y - 16)
	var/dev = sqrt(dx * dx + dy * dy)
	var/angle=0
	if(dev > 0)
		angle=arccos(dy / sqrt(dx * dx + dy * dy))
	var/ang = (dx>=0) ? (angle) : (360-angle)
	return ang